﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Threading.Tasks;
using System.Web;
using System.Web.Services;
using System.Web.UI;
using SrPagoApi;
using SrPagoApi.Response;

namespace SrEcommerceDemo.Customer
{

    public partial class Create : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            
        }

        [WebMethod]
        public static string CreateCustomerAction(string name, string email)
        {
            var customer = Task.Run(async () =>
            {
                var result = await CreateCustomer(name, email);

                return result;
            }).GetAwaiter().GetResult();

            if (customer.error != null)
            {
                return "Error: " + customer.error.message;
            }
            else
            {
                var result = $"Customer {customer.result.name} was registered.";//
                return "Success: " + result;
            }
        }

        public static async Task<CustomerResponse> CreateCustomer(string name, string email)
        {
            try
            {
                SrPago.ApiKey = ConfigurationManager.AppSettings.Get("ApiKey");
                SrPago.ApiSecret = ConfigurationManager.AppSettings.Get("ApiSecret");
                SrPago.LiveMode = Boolean.Parse(ConfigurationManager.AppSettings.Get("LiveMode"));

                Dictionary<string, object> customerParams = new Dictionary<string, object>
                {
                    { "name", name },
                    { "email", email }
                };

                CustomerService customerService = new CustomerService();
                CustomerResponse customer = await customerService.Create(customerParams);

                return customer;
            }
            catch (InvalidParamException ex)
            {
                System.Console.WriteLine(ex.Message);
                System.Console.WriteLine(ex.StackTrace);
            }
            catch (SrPagoException ex)
            {
                System.Console.WriteLine(ex.Message);
                System.Console.WriteLine(ex.StackTrace);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine(ex.Message);
                System.Console.WriteLine(ex.StackTrace);
            }

            return null;
        }

        void btnBack_Click(Object sender, EventArgs e)
        {
            
        }
    }
}
