﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Threading.Tasks;
using System.Web;
using System.Web.UI;
using SrPagoApi;
using SrPagoApi.Response;

namespace SrEcommerceDemo.Customer
{

    public partial class Principal : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            var customers = Task.Run(async () =>
            {
                var result = await GetCustomers();

                return result;
            }).GetAwaiter().GetResult();

            //grCustomers.AutoGenerateColumns = true;
            grCustomers.DataSource = customers.result.customers;
            grCustomers.DataBind();

        }

        public static async Task<CustomerListResponse> GetCustomers()
        {
            try
            {
                SrPago.ApiKey = ConfigurationManager.AppSettings.Get("ApiKey");
                SrPago.ApiSecret = ConfigurationManager.AppSettings.Get("ApiSecret");
                SrPago.LiveMode = Boolean.Parse(ConfigurationManager.AppSettings.Get("LiveMode"));

                CustomerService customerService = new CustomerService();
                CustomerListResponse customers = await customerService.List();

                return customers;
            }
            catch (InvalidParamException ex)
            {
                System.Console.WriteLine(ex.Message);
                System.Console.WriteLine(ex.StackTrace);
            }
            catch (SrPagoException ex)
            {
                System.Console.WriteLine(ex.Message);
                System.Console.WriteLine(ex.StackTrace);
            }
            catch (Exception ex)
            {
                System.Console.WriteLine(ex.Message);
                System.Console.WriteLine(ex.StackTrace);
            }

            return null;
        }
    }
}
