﻿
$(document).ready(function() {
  
  SrPago.terminal.setup({
    onPaymentStatusChange: function(evt) {
      $(".payment-status").html(evt.result.code);
            
      if(evt.result.code == "payment_success"){
            var detail = evt.result.detail;
            var crd = "Autorizaci&oacute;n: " + detail.authorization_code +" ("+detail.card.type +" "+ detail.card.number+")";
            $(".payment-status").html(evt.result.code + "<br/>" + crd);
      }      

    },
    onPaymentError: function(evt) {
      $(".payment-status").html(evt.error.code + "<br/>" + evt.error.message);
    }
  });

  var log = function(txt) {
    $("#response-creation").html($("#response-creation").html() + "<br/>" + txt);
  };

  $('#create-payment').click(function(event) {
    $("#response-creation").html("");

    //1.- Validate parameters
    if (!formIsValid()) {
      return;
    }


    //2.- Crear Orden de pago
    CreatePayment(function() {
      //3.- Conectar a Terminal seleccionada
      TerminalConnect(function() {
        //4.- Realizar Cargo en Terminal
        TerminalCharge();
      });
    });
  });

  $('#terminal-status').click(function(event) {
    TerminalStatus();
  });

  var formIsValid = function() {
    var terminalId = $('.terminal').val();
    var amount = $('.amount').val();

    log("<hr><b>Validando params</b>");


    result = true;

    if (terminals.length == 0) {
      log("-- ERROR NO HAY TERMINALES ACTIVAS");
      result = false;
    }

    if (!(amount > 0 && amount < 1000000)) {
      log("-- ERROR EL MONTO DEBE SER MAYOR A 1 MX");
      result = false;
    }
    if (terminalId == "") {
      log("-- DEBE SELECCIONAR UNA TERMINAL");
      result = false;
    }

    return result;
  }




  var TerminalConnect = function(onSuccess) {
    log("<hr><b>Conectando a terminal " + $('.terminal').val() + "</b>");

    var terminalId = $('.terminal').val();



    //-- Create payment with selected terminal
    SrPago.terminal.connect(terminalId,
      function(result) {
        log('Se ha conectado correctamente');
        $(".terminal-status").html("conectado");
        onSuccess();
      },
      function(error) {
        $(".terminal-status").html("error al conectar");
        log(JSON.stringify(error));
      }
    );
  }



  var CreatePayment = function(onSuccess) {
    log("<hr><b>Creando pago a con llaves privadas</b>");

    var amount = $('.amount').val();

    currentToken = "";


    $.ajax({
      url: 'Create.aspx/CreatePaymentAction',
      type: "POST",
      data: "{'amount':'" + amount + "', 'referenceNumber':'" + $('.referenceNumber').val() + "', 'referenceDescription':'" + $('.referenceDescription').val() + "'}", //Enviar otros parametros
      contentType: "application/json; charset=utf-8",
      dataType: "json",
      success: function(response) {
        

        var response = JSON.parse(response.d);

        if (response.result) {

          currentToken = response.result.token;
          log("Orden " + currentToken);
          onSuccess();
        } else {
          log("Error al crear pago ");
        }
      },
      failure: function(response) {
        log("Error al crear pago " + response.d);
      }
    }).done(function(response) {});;
  }


  var TerminalCharge = function() {
    log("<hr><b>Cobrar</b>");
    SrPago.terminal.charge({
        token: currentToken
      },
      function(result) {
        log("Cobro iniciado correctamente ... ");


      },
      function(error) {
        log("Error al iniciar el cobro");
        

      }
    );
  };


  var TerminalStatus = function() {
    log("<hr><b>Status de Terminal</b>");
    SrPago.terminal.status(
      function(result) {
        log(JSON.stringify(result));

      },
      function(error) {
        log(JSON.stringify(error));

      }
    );
  };


  var terminals = [];
  var currentToken = "";




  var GetTerminals = function() {

    $("#response-terminals").html("obteniendo terminales...");
    $.ajax({
      url: 'Create.aspx/GetTerminalsAction',
      type: "GET",
      contentType: "application/json;",
      dataType: "json",
      success: function(response) {
        var response = JSON.parse(response.d);
        terminals = [];

        if (response && response.result) {
          terminals = response.result;
        }
        SrPago.terminal.terminals(terminals);

        ShowTerminals(terminals);
      },
      failure: function(response) {
        $("#terminals").html("<b>NO HAY TERMINALES CREADAS EN SU CUENTA</b>");
      }
    }).done(function(response) {});;

  }

  var ShowTerminals = function(terminals) {
    var html = "<b>NO HAY TERMINALES 'ONLINE' EN SU CUENTA</b>";

    if (terminals.length > 0) {
      var content = "<select name='terminal' class='terminal form-control'>";
      content += "<option value='' " + (i == 0 ? "selected" : "") + ">SELECCIONAR TERMINAL</option>";

      var i = 0;
      for (var x in terminals) {
        var item = terminals[x];
        value = item.label + "  **" + item.uuid;
        if (item.status == "online") {
          content += "<option value='" + item.id + "'>" + value + " (" + item.ip_address + ")</option>";
          i++;
        }
      }

      content += "</select>";
    }

    if (i > 0) {
      html = content;
    }

    $("#terminals").html(html);
  }


  GetTerminals();

});