﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Threading.Tasks;
using System.Web;
using System.Web.Services;
using System.Web.Script.Serialization;
using System.Web.UI;
using SrPagoApi;
using SrPagoApi.Response;

namespace SrEcommerceDemo.Terminal
{

    public partial class Create : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        { }

        [WebMethod]
        public static string CreatePaymentAction(string amount, string referenceNumber, string referenceDescription)
        {
            var payment = Task.Run(async () =>
            {
                var result = await CreatePayment(amount, referenceNumber, referenceDescription);

                return result;
            }).GetAwaiter().GetResult();

            return new JavaScriptSerializer().Serialize(payment);

        }

        [WebMethod]
        public static string GetTerminalsAction()
        {
            var terminalResponse = Task.Run(async () =>
            {
                var result = await getTerminals();

                return result;
            }).GetAwaiter().GetResult();

            return new JavaScriptSerializer().Serialize(terminalResponse);
        }


        public static async Task<TerminalResponse> getTerminals()
        {

            TerminalResponse terminal = new TerminalResponse();
            try
            {
                SrPago.ApiKey = ConfigurationManager.AppSettings.Get("ApiKey");
                SrPago.ApiSecret = ConfigurationManager.AppSettings.Get("ApiSecret");
                SrPago.LiveMode = Boolean.Parse(ConfigurationManager.AppSettings.Get("LiveMode"));

                TerminalService terminalService = new TerminalService();
                terminal = await terminalService.Get();

                return terminal;
            }
            catch (Exception ex)
            {
                terminal.error = new Error();
                terminal.error.code = "Exception";

                System.Console.WriteLine(ex.Message);
                System.Console.WriteLine(ex.StackTrace);
            }



            return terminal;
        }

        public static async Task<PaymentResponse> CreatePayment(string amount, string referenceNumber, string referenceDescription)
        {
            try
            {
                SrPago.ApiKey = ConfigurationManager.AppSettings.Get("ApiKey");
                SrPago.ApiSecret = ConfigurationManager.AppSettings.Get("ApiSecret");
                SrPago.LiveMode = Boolean.Parse(ConfigurationManager.AppSettings.Get("LiveMode"));



                Dictionary<string, object> paymentParams = new Dictionary<string, object>
                {
                    { "amount", amount },
                    { "reference", referenceNumber },
                    { "description", referenceDescription}
                };

                PaymentService paymentService = new PaymentService();
                PaymentResponse payment = await paymentService.Create(paymentParams);


                return payment;
            }
            catch (Exception ex)
            {
                System.Console.WriteLine(ex.Message);
                System.Console.WriteLine(ex.StackTrace);
            }

            return null;
        }

        void btnBack_Click(Object sender, EventArgs e)
        {

        }
    }
}